Index: trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeSpline.h
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeSpline.h	(revision 8144)
+++ trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeSpline.h	(revision 8154)
@@ -11,99 +11,95 @@
 
 class MPedestalPix;
+
 class MExtractTimeAndChargeSpline : public MExtractTimeAndCharge
 {
+private:
+    static const Byte_t  fgHiGainFirst;      //! Default for fHiGainFirst  (now set to: 2)
+    static const Byte_t  fgHiGainLast;       //! Default for fHiGainLast   (now set to: 14)
+    static const Byte_t  fgLoGainFirst;      //! Default for fLoGainFirst  (now set to: 2)
+    static const Byte_t  fgLoGainLast;       //! Default for fLoGainLast   (now set to: 14)
+    static const Float_t fgResolution;       //! Default for fResolution   (now set to: 0.003)
+    static const Float_t fgRiseTimeHiGain;   //! Default for fRiseTime     (now set to: 1.5)
+    static const Float_t fgFallTimeHiGain;   //! Default for fFallTime     (now set to: 4.5)
+    static const Float_t fgLoGainStretch;    //! Default for fLoGainStretch    (now set to: 1.5)
+    static const Float_t fgOffsetLoGain;     //! Default for fOffsetLoGain     (now set to 1.7)
+//    static const Float_t fgLoGainStartShift; //! Default for fLoGainStartShift (now set to -1.6)
+
+//    MArrayF fHiGainSignal;                   //! Need fast access to the signals in a float way
+//    MArrayF fLoGainSignal;                   //! Store them in separate arrays
+    MArrayF fHiGainFirstDeriv;               //! High-gain discretized first derivatives
+    MArrayF fLoGainFirstDeriv;               //! Low-gain discretized first derivatives
+    MArrayF fHiGainSecondDeriv;              //! High-gain discretized second derivatives
+    MArrayF fLoGainSecondDeriv;              //! Low-gain discretized second derivatives
+
+    Float_t fResolution;                     // The time resolution in FADC units
+
+    Float_t fRiseTimeHiGain;                 // The usual rise time of the pulse in the high-gain
+    Float_t fFallTimeHiGain;                 // The usual fall time of the pulse in the high-gain
+    Float_t fRiseTimeLoGain;                 // The usual rise time of the pulse in the low-gain
+    Float_t fFallTimeLoGain;                 // The usual fall time of the pulse in the low-gain
+
+    Float_t fLoGainStretch;                  // The stretch of the low-gain w.r.t. the high-gain pulse
+
+    Int_t   fRandomIter;                     //! Counter used to randomize weights for noise calculation
+
+    Int_t   ReadEnv(const TEnv &env, TString prefix, Bool_t print);
+    Bool_t  InitArrays();
+
+public:
+    enum ExtractionType_t { kAmplitude, kIntegral };    //! Possible time and charge extraction types
 
 private:
-  
-  static const Byte_t  fgHiGainFirst;      //! Default for fHiGainFirst  (now set to: 2)
-  static const Byte_t  fgHiGainLast;       //! Default for fHiGainLast   (now set to: 14)
-  static const Byte_t  fgLoGainFirst;      //! Default for fLoGainFirst  (now set to: 2)
-  static const Byte_t  fgLoGainLast;       //! Default for fLoGainLast   (now set to: 14)
-  static const Float_t fgResolution;       //! Default for fResolution   (now set to: 0.003)
-  static const Float_t fgRiseTimeHiGain;   //! Default for fRiseTime     (now set to: 1.5)
-  static const Float_t fgFallTimeHiGain;   //! Default for fFallTime     (now set to: 4.5)
-  static const Float_t fgLoGainStretch;    //! Default for fLoGainStretch    (now set to: 1.5)
-  static const Float_t fgOffsetLoGain;     //! Default for fOffsetLoGain     (now set to 1.7)
-  static const Float_t fgLoGainStartShift; //! Default for fLoGainStartShift (now set to -1.6)
-  
-  MArrayF fHiGainSignal;                //! Need fast access to the signals in a float way
-  MArrayF fLoGainSignal;                //! Store them in separate arrays
-  MArrayF fHiGainFirstDeriv;            //! High-gain discretized first derivatives
-  MArrayF fLoGainFirstDeriv;            //! Low-gain discretized first derivatives
-  MArrayF fHiGainSecondDeriv;           //! High-gain discretized second derivatives
-  MArrayF fLoGainSecondDeriv;           //! Low-gain discretized second derivatives
-
-  Float_t fAbMax;                       //! Current maximum of the spline
-  Float_t fAbMaxPos;                    //! Current position of the maximum of the spline
-  Float_t fHalfMax;                     //! Current half maximum of the spline
-
-  Float_t fResolution;                  // The time resolution in FADC units
-
-  Float_t fRiseTimeHiGain;              // The usual rise time of the pulse in the high-gain
-  Float_t fFallTimeHiGain;              // The usual fall time of the pulse in the high-gain
-  Float_t fRiseTimeLoGain;              // The usual rise time of the pulse in the low-gain
-  Float_t fFallTimeLoGain;              // The usual fall time of the pulse in the low-gain
-
-  Float_t fLoGainStretch;               // The stretch of the low-gain w.r.t. the high-gain pulse
-
-  Int_t   fRandomIter;                  //! Counter used to randomize weights for noise calculation
-  
-  Int_t   ReadEnv(const TEnv &env, TString prefix, Bool_t print);
-
-  Bool_t  InitArrays();
-  
-  Float_t CalcIntegralHiGain(Float_t start, Float_t range) const;
-  Float_t CalcIntegralLoGain(Float_t start, Float_t range) const;
-
-public:  
-  enum ExtractionType_t { kAmplitude, kIntegral };    //! Possible time and charge extraction types
-
-private:
-  
-  ExtractionType_t fExtractionType;
+    ExtractionType_t fExtractionType;
 
 public:
+    MExtractTimeAndChargeSpline(const char *name=NULL, const char *title=NULL);
+    ~MExtractTimeAndChargeSpline() {}
 
-  MExtractTimeAndChargeSpline(const char *name=NULL, const char *title=NULL);
-  ~MExtractTimeAndChargeSpline() {}
+    Float_t GetRiseTimeHiGain() const { return fRiseTimeHiGain; }
+    Float_t GetFallTimeHiGain() const { return fFallTimeHiGain; }
 
-  Float_t GetRiseTimeHiGain() const { return fRiseTimeHiGain; }
-  Float_t GetFallTimeHiGain() const { return fFallTimeHiGain; }
+    void SetRange(Byte_t hifirst=0, Byte_t hilast=0, Byte_t lofirst=0, Byte_t lolast=0 );
 
-  void SetRange      ( Byte_t hifirst=0, Byte_t hilast=0, Byte_t lofirst=0, Byte_t lolast=0 );  
-  void SetResolution ( const Float_t f=fgResolution  )  { fResolution  = f;  }
-  void SetRiseTimeHiGain( const Float_t f=fgRiseTimeHiGain    )
+    void SetResolution(const Float_t f=fgResolution)  { fResolution  = f;  }
+
+    void SetRiseTimeHiGain(const Float_t f=fgRiseTimeHiGain)
     {
-      fRiseTimeHiGain    = f;
-      fRiseTimeLoGain    = f*fLoGainStretch;
-      fSqrtHiGainSamples = TMath::Sqrt(fNumHiGainSamples);
-      fWindowSizeHiGain  = TMath::Nint(fRiseTimeHiGain + fFallTimeHiGain);
+        fRiseTimeHiGain    = f;
+        fRiseTimeLoGain    = f*fLoGainStretch;
+        fSqrtHiGainSamples = TMath::Sqrt(fNumHiGainSamples);
+        fWindowSizeHiGain  = TMath::Nint(fRiseTimeHiGain + fFallTimeHiGain);
     }
-  void SetFallTimeHiGain( const Float_t f=fgFallTimeHiGain    )
+    void SetFallTimeHiGain(const Float_t f=fgFallTimeHiGain)
     {
-      fFallTimeHiGain    = f;
-      fFallTimeLoGain    = f*fLoGainStretch;
-      fNumHiGainSamples  = fRiseTimeHiGain + fFallTimeHiGain;
-      fNumLoGainSamples  = fLoGainLast ? fRiseTimeLoGain + fFallTimeLoGain : 0.;
-      fSqrtLoGainSamples = TMath::Sqrt(fNumLoGainSamples);
-      fWindowSizeLoGain  = TMath::Nint(fRiseTimeLoGain + fFallTimeLoGain);
+        fFallTimeHiGain    = f;
+        fFallTimeLoGain    = f*fLoGainStretch;
+        fNumHiGainSamples  = fRiseTimeHiGain + fFallTimeHiGain;
+        fNumLoGainSamples  = fLoGainLast ? fRiseTimeLoGain + fFallTimeLoGain : 0.;
+        fSqrtLoGainSamples = TMath::Sqrt(fNumLoGainSamples);
+        fWindowSizeLoGain  = TMath::Nint(fRiseTimeLoGain + fFallTimeLoGain);
     }
 
-  void SetLoGainStretch ( const Float_t f=fgLoGainStretch    )  { fLoGainStretch = f;   }
-  
-  void SetChargeType ( const ExtractionType_t typ=kIntegral);
-  
-  void FindTimeAndChargeHiGain(Byte_t *first, Byte_t *logain, Float_t &sum, Float_t &dsum,
-                               Float_t &time, Float_t &dtime,
-                               Byte_t &sat, const MPedestalPix &ped, const Bool_t abflag);
-  void FindTimeAndChargeLoGain(Byte_t *first, Float_t &sum,  Float_t &dsum,
-                               Float_t &time, Float_t &dtime,
-                               Byte_t &sat, const MPedestalPix &ped, const Bool_t abflag);
+    void SetLoGainStretch(const Float_t f=fgLoGainStretch) { fLoGainStretch = f;   }
 
-  ClassDef(MExtractTimeAndChargeSpline, 4)   // Task to Extract Arrival Times and Charges using a Cubic Spline
+    void SetChargeType(const ExtractionType_t typ=kIntegral);
+/*
+    void FindTimeAndChargeHiGain(Byte_t *first, Byte_t *logain, Float_t &sum, Float_t &dsum,
+                                 Float_t &time, Float_t &dtime,
+                                 Byte_t &sat, const MPedestalPix &ped, const Bool_t abflag);
+    void FindTimeAndChargeLoGain(Byte_t *first, Float_t &sum,  Float_t &dsum,
+                                 Float_t &time, Float_t &dtime,
+                                 Byte_t &sat, const MPedestalPix &ped, const Bool_t abflag);
+*/
+    void FindTimeAndChargeHiGain2(const Float_t *firstused, Int_t num, Float_t &sum, Float_t &dsum,
+                                  Float_t &time, Float_t &dtime,
+                                  Byte_t sat, Int_t maxpos);
+
+    void FindTimeAndChargeLoGain2(const Float_t *firstused, Int_t num, Float_t &sum,  Float_t &dsum,
+                                  Float_t &time, Float_t &dtime,
+                                  Byte_t sat, Int_t maxpos);
+
+    ClassDef(MExtractTimeAndChargeSpline, 4)   // Task to Extract Arrival Times and Charges using a Cubic Spline
 };
 
 #endif
-
-
-
Index: trunk/MagicSoft/Mars/msignal/MExtractedSignalPix.h
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractedSignalPix.h	(revision 8144)
+++ trunk/MagicSoft/Mars/msignal/MExtractedSignalPix.h	(revision 8154)
@@ -15,6 +15,9 @@
   Float_t fExtractedSignalLoGainError; // error of the mean value of the extracted signal
 
-  Byte_t fNumHiGainSaturated;          // Number of first hi-gain slice which has saturated (could be negative if already the first slice saturates)
-  Byte_t fNumLoGainSaturated;          // Number of first lo-gain slices which have saturated
+  Byte_t fNumHiGainSaturated;          // Number of how many hi-gain slices saturated
+  Byte_t fNumLoGainSaturated;          // Number of how many lo-gain slices saturated
+
+  Byte_t GetNumHiGainSaturated() const { return fNumHiGainSaturated; }
+  Byte_t GetNumLoGainSaturated() const { return fNumLoGainSaturated; }
 
 public:
@@ -36,7 +39,4 @@
   Float_t GetExtractedSignalLoGainError() const { return fExtractedSignalLoGainError;  }
 
-  Byte_t GetNumHiGainSaturated()          const { return fNumHiGainSaturated;          }
-  Byte_t GetNumLoGainSaturated()          const { return fNumLoGainSaturated;          }
-
   Bool_t IsHiGainSaturated()              const { return fNumHiGainSaturated>0;        }
   Bool_t IsLoGainSaturated()              const { return fNumLoGainSaturated>0;        }
Index: trunk/MagicSoft/Mars/msignal/MExtractor.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractor.cc	(revision 8144)
+++ trunk/MagicSoft/Mars/msignal/MExtractor.cc	(revision 8154)
@@ -93,4 +93,5 @@
 #include "MPedestalCam.h"
 #include "MPedestalPix.h"
+//#include "MPedestalSubtractEvt.h"
 
 #include "MExtractedSignalCam.h"
@@ -101,5 +102,5 @@
 using namespace std;
 
-const Byte_t  MExtractor::fgSaturationLimit = 250;
+const Byte_t  MExtractor::fgSaturationLimit = 245;
 const TString MExtractor::fgNamePedestalCam = "MPedestalCam";
 const TString MExtractor::fgNameSignalCam   = "MExtractedSignalCam";
@@ -123,6 +124,7 @@
 MExtractor::MExtractor(const char *name, const char *title)
     : fResolutionPerPheHiGain(0), fResolutionPerPheLoGain(0),
-      fPedestals(NULL), fSignals(NULL), fRawEvt(NULL), fRunHeader(NULL),
-      fHiLoLast(0), fNumHiGainSamples(0), fNumLoGainSamples(0)
+    fPedestals(NULL), fSignals(NULL), fRawEvt(NULL), fRunHeader(NULL),
+    fSignal(NULL),
+      /*fHiLoLast(0),*/ fNumHiGainSamples(0), fNumLoGainSamples(0)
 {
     fName  = name  ? name  : "MExtractor";
@@ -172,4 +174,11 @@
     {
         *fLog << err << AddSerialNumber("MRawRunHeader") << " not found... aborting." << endl;
+        return kFALSE;
+    }
+
+    fSignal = (MPedestalSubtractedEvt*)pList->FindObject(AddSerialNumber("MPedestalSubtractedEvt"));
+    if (!fSignal)
+    {
+        *fLog << err << AddSerialNumber("MPedestalSubtractedEvt") << " not found... aborting." << endl;
         return kFALSE;
     }
@@ -231,5 +240,20 @@
 Bool_t MExtractor::ReInit(MParList *pList)
 {
-
+    const Int_t numl = fRunHeader->GetNumSamplesLoGain();
+    const Int_t numh = fRunHeader->GetNumSamplesHiGain();
+    const Int_t num  = numh+numl;
+
+    if (fHiGainLast>=num)
+    {
+        *fLog << err << "ERROR - Last hi-gain slice must not exceed " << num-1 << endl;
+        return kFALSE;
+    }
+    if (fLoGainLast>=num)
+    {
+        *fLog << err << "ERROR - Last lo-gain slice must not exceed " << num-1 << endl;
+        return kFALSE;
+    }
+
+/*
   const Int_t logainsamples = fRunHeader->GetNumSamplesLoGain();
 
@@ -289,5 +313,6 @@
     }
   
-  return kTRUE;
+  */
+    return kTRUE;
 }
 
@@ -431,5 +456,5 @@
     *fLog << " Hi Gain Range:      " << Form("%2d %2d", fHiGainFirst, fHiGainLast) << endl;
     *fLog << " Lo Gain Range:      " << Form("%2d %2d", fLoGainFirst, fLoGainLast) << endl;
-    *fLog << " Gain Overlap to Lo: " << Form("%2d", fHiLoLast)        << endl;
+//    *fLog << " Gain Overlap to Lo: " << Form("%2d", fHiLoLast)        << endl;
     *fLog << " Saturation Lim:     " << Form("%3d", fSaturationLimit) << endl;
     *fLog << " Num Samples Hi/Lo:  " << Form("%2.1f %2.1f", fNumHiGainSamples, fNumLoGainSamples) << endl;
Index: trunk/MagicSoft/Mars/msignal/MExtractor.h
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractor.h	(revision 8144)
+++ trunk/MagicSoft/Mars/msignal/MExtractor.h	(revision 8154)
@@ -18,4 +18,5 @@
 
 class MPedestalCam;
+class MPedestalSubtractedEvt;
 class MExtractedSignalCam;
 
@@ -42,4 +43,6 @@
   MRawEvtData         *fRawEvt;            //! Raw event data (time slices)
   MRawRunHeader       *fRunHeader;         //! RunHeader information
+
+  MPedestalSubtractedEvt *fSignal;         //!
                                        
   Byte_t   fHiGainFirst;                   // First FADC slice nr. to extract the High Gain signal
@@ -48,5 +51,5 @@
   Byte_t   fLoGainLast;                    // Last FADC slice nr. to extract the Low Gain signal
                                            
-  Byte_t   fHiLoLast;                      // Number of slices in fLoGainSamples counted for the High-Gain signal
+//  Byte_t   fHiLoLast;                      // Number of slices in fLoGainSamples counted for the High-Gain signal
                                            
   Float_t  fNumHiGainSamples;              // Number High Gain FADC slices used to extract the signal
@@ -91,4 +94,5 @@
   Float_t GetResolutionPerPheHiGain() const { return fResolutionPerPheHiGain; }
   Float_t GetResolutionPerPheLoGain() const { return fResolutionPerPheLoGain; }
+  Byte_t  GetSaturationLimit() const { return fSaturationLimit; }
 
   Bool_t  IsNoiseCalculation () const { return fNoiseCalculation; }
@@ -107,9 +111,10 @@
 
   void SetPedestals (MPedestalCam *pedcam)   { fPedestals = pedcam; }
+  MPedestalCam *GetPedestals()   { return fPedestals; }
 
   // TObject
   void Clear(Option_t *o="") 
     {
-      fHiGainFirst = fHiGainLast = fLoGainFirst = fLoGainLast = fHiLoLast = 0;
+      fHiGainFirst = fHiGainLast = fLoGainFirst = fLoGainLast = /*fHiLoLast =*/ 0;
     }
 
Index: trunk/MagicSoft/Mars/msignal/Makefile
===================================================================
--- trunk/MagicSoft/Mars/msignal/Makefile	(revision 8144)
+++ trunk/MagicSoft/Mars/msignal/Makefile	(revision 8154)
@@ -21,5 +21,5 @@
 INCLUDES =  -I. -I../mbase -I../mgui -I../mraw -I../manalysis \
             -I../mgeom -I../mtools -I../mpedestal -I../mbadpixels \
-            -I../mcalib
+            -I../mcalib -I../mextralgo
 
 # mgui (MCamEvent):         MExtractSignalCam
